<?php

/*********************************************************************

 ニュースレスポンスdisplayプラグイン (2015/09/09)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

//外部ファイル読み込み
require_once FREO_MAIN_DIR . 'freo/plugins/security_plugin_newsres.php';

/* メイン処理 */
function freo_display_newsres()
{
	global $freo;

	//パラメータ検証
	if (!isset($_GET['news_id']) and isset($freo->parameters[2])) {
		$_GET['news_id'] = $freo->parameters[2];
	}

	//検索条件設定
	$ascending = false;
	if ($freo->config['plugin']['newsres']['newsres_order'] == 'ascend') {
		$ascending = true;
	}
	if ($ascending == true) {
		$order = ' id';
	} else {
		$order = ' id DESC';
	}

	//ニュースレスポンス取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_newsreses WHERE news_id = :news_id ORDER BY' . $order);
	$stmt->bindValue(':news_id', $_GET['news_id']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_newsreses = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_newsreses[$data['id']] = $data;
	}

	//ニュースレスポンスID取得
	$plugin_newsres_keys = array_keys($plugin_newsreses);

	//ニュースレスポンス保護データ取得
	$plugin_newsres_securities = freo_security_plugin_newsres('user', $plugin_newsres_keys);

	foreach ($plugin_newsres_securities as $id => $security) {
		if (!$security) {
			continue;
		}

		$plugin_newsreses[$id]['name']      = $freo->config['plugin']['newsres']['restriction_name'];
		$plugin_newsreses[$id]['mail']      = null;
		$plugin_newsreses[$id]['url']       = null;
		$plugin_newsreses[$id]['text']      = $freo->config['plugin']['newsres']['restriction_text'];

	}

	//ニュース全件取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_newses');
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_news_alls = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_news_alls[$data['id']] = $data;
	}

	//ニュースID取得
	$plugin_news_all_keys = array_keys($plugin_news_alls);

	//データ初期化
	$newsres_counts = array();
	foreach ($plugin_news_all_keys as $plugin_news_all) {
		$newsres_counts[$plugin_news_all] = 1;
	}

	//ニュースごとのニュースレスポンス数取得
	$stmt = $freo->pdo->query('SELECT news_id, COUNT(*) FROM ' . FREO_DATABASE_PREFIX . 'plugin_newsreses WHERE news_id IN(' . implode(',', $plugin_news_all_keys) . ') GROUP BY news_id');
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	while ($data = $stmt->fetch(PDO::FETCH_NUM)) {
		$newsres_counts[$data[0]] = 1 + $data[1];
	}


	//データ割当
	$freo->smarty->assign(array(
		'token'                 => freo_token('create'),
		'plugin_newsreses'      => $plugin_newsreses,
		'plugin_news_alls'      => $plugin_news_alls,
		'plugin_newsres_counts' => $newsres_counts
	));

	return;
}

?>
